program XYZTry;

uses
  SvcMgr,
  Forms,
  Windows,
  SysUtils,
  WinSvc,
  XYZForm in 'XYZForm.pas' {XYZMainForm},
  XYZSvc in 'XYZSvc.pas' {XYZService: TService};

{$R *.RES}

//The default: run as an APPLICATION
// "/install" -> SERVICE 
//  (ContorlPanel/Administrative Toos/Services:XYZ->START/STOP)
// "/uninstall" -> APPLICATION 
//  (Run->XYZTry.exe)

var
  HCMutex: THANDLE;

function Installing: Boolean;
begin
  Result := FindCmdLineSwitch('INSTALL',['-','\','/'], True) or
            FindCmdLineSwitch('UNINSTALL',['-','\','/'], True);
end;

function StartService: Boolean;
var
  Mgr, Svc: Integer;
  UserName, ServiceStartName: string;
  Config: Pointer;
  Size: DWord;
begin
  Result := False;
  Mgr := OpenSCManager(nil, nil, SC_MANAGER_ALL_ACCESS);
  if Mgr <> 0 then
  begin
    Svc := OpenService(Mgr, 'XYZService', SERVICE_ALL_ACCESS);
    Result := Svc <> 0;
    if Result then
    begin
      QueryServiceConfig(Svc, nil, 0, Size);
      Config := AllocMem(Size);
      try
        QueryServiceConfig(Svc, Config, Size, Size);
        ServiceStartName := PQueryServiceConfig(Config)^.lpServiceStartName;
        if CompareText(ServiceStartName, 'LocalSystem') = 0 then
          ServiceStartName := 'SYSTEM';
      finally
        Dispose(Config);
      end;
      CloseServiceHandle(Svc);
    end;
    CloseServiceHandle(Mgr);
  end;
  if Result then
  begin
    Size := 256;
    SetLength(UserName, Size);
    GetUserName(PChar(UserName), Size);
    SetLength(UserName, StrLen(PChar(UserName)));
    Result := (CompareText(UserName, ServiceStartName) = 0);
  end;
end;

begin
  HCMutex:= INVALID_HANDLE_VALUE;
  If NOT Installing Then Begin
    HCMutex:= CreateMutex(NIL, TRUE, 'HCP_SRVR');
    If GetLastError = ERROR_ALREADY_EXISTS Then Begin
      MessageBox(0, 'mr fut', 'HCPatikaService', MB_ICONERROR);
      Halt;
    End;
  End;

  If Installing OR StartService then begin
    SvcMgr.Application.Initialize;
    // HCPatikaService := THCPatikaService.CreateNew(SvcMgr.Application, 0);
    SvcMgr.Application.CreateForm(TXYZService, XYZService);
  SvcMgr.Application.CreateForm(TXYZMainForm, XYZMainForm);
    SvcMgr.Application.Run;
  end else begin
    Forms.Application.Initialize;
    Forms.Application.ShowMainForm:= False;
    Forms.Application.CreateForm(TXYZMainForm, XYZMainForm);
    XYZMainForm.Initialize( FALSE );
    Forms.Application.Run;
  end;

  If (NOT Installing) AND (HCMutex<>INVALID_HANDLE_VALUE) Then Begin
    ReleaseMutex(HCMutex);
    CloseHandle(HCMutex);
    GetLastError();
  End;
end.
